<template>
  <rui-loading v-if="!patch" class="-mvd">{{ $t('generic.loading') }}</rui-loading>
  <div v-else>
    <div class="_container -mbd">
      <div class="-flex -gap">
        <h2 class="-flex -gap -flex--grow -text--ellipsis">
          <rui-button v-show="$smallerThan('medium')" :to="{name: 'inventory'}" icon="caret-left" :title="$t('generic.back')" />

          <rui-icon :name="geometryIcon(patch.geometryType)" class="-flex-none" />
          {{ patch.displayName }}
        </h2>
        <gpa-patch-actions :patch="patch" context="inventory" />
      </div>
      <small>{{ $t('generic.definition', {value: $t('activerecord.attributes.patch.created_at')}) }}{{ $d(patch.createdAt) }}</small>
    </div>

    <rui-tabs no-text-on-small>
      <rui-button :to="{name: 'inventory-patch-elements', params: {patchId: $route.params.patchId}}" :caption="$t('js.inventory.panel.elements')" icon="leaf" />
      <rui-button :to="{name: 'inventory-patch-observations', params: {patchId: $route.params.patchId}}" icon="notebook">
        {{ $t('js.generic.observations') }}
        <small>({{ patch.observationsCount }})</small>
      </rui-button>
      <rui-button :to="{name: 'inventory-patch-tasks', params: {patchId: $route.params.patchId}}" :caption="$t('js.generic.tasks')" icon="checks" />
      <rui-toolbar-spring />
      <rui-button :to="{name: 'inventory-patch-activity', params: {patchId: $route.params.patchId}}" :caption="$t('js.generic.activity')" icon="activity" />
    </rui-tabs>

    <router-view />
  </div>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'
import RuiTabs from '@experiments-labs/rise_ui/src/components/Tabs/Tabs.vue'
import RuiToolbarSpring from '@experiments-labs/rise_ui/src/components/Toolbar/ToolbarSpring.vue'

import GpaPatchActions from './Patches/_Actions.vue'
import { geometryIcon } from '../../../shapeIcons'

/**
 * @typedef {import('../../../classes/models/Patch')} Patch
 */

/**
 * Inventory page to display details on an Element
 */
export default {
  name: 'GpaInventoryPatch',
  components: { RuiToolbarSpring, RuiTabs, RuiIcon, RuiButton, RuiLoading, GpaPatchActions },
  computed: {
    /** @returns {Patch} Patch to display */
    patch () { return this.$store.getters.patch(parseInt(this.$route.params.patchId, 10)) },
  },
  methods: {
    geometryIcon,
  },
}
</script>
